<?php

/**
 * notifica_avoca actions.
 *
 * @package    cobro_coactivo
 * @subpackage notifica_avoca
 * @author     ManuelEnriqueParedesLopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class notifica_avocaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_NOTIFICA_AVOCA',
        'CBR_AVOCA_REMIS_AGRUP_V',
        //'CBR_REMISION_TITULO',
        'CBR_AVOCA_CONOC',
        'CBR_TIPO_DOCUMENTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_AVOCA_REMIS_AGRUP_V,LEFT' =>
        array(
            'id_avoca_conoc' => 'CBR_NOTIFICA_AVOCA'
        ),
        'CBR_AVOCA_CONOC,LEFT' =>
        array(
            'id_avoca_conoc' => 'CBR_NOTIFICA_AVOCA'
        ),
        'CBR_TIPO_DOCUMENTO,LEFT' =>
        array(
            'id_tipo_documento' => 'CBR_AVOCA_CONOC'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_NOTIFICA_AVOCA' =>
        array(
            'id_notifica_avoca' => 'id_notifica_avoca',
            'id_avoca_conoc' => 'id_avoca_conoc',
            'fecha' => 'fecha',
            'usuario_log' => 'usuario_log',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto',
            'estado' => 'estado',
            'fecha_log' => 'fecha_log'
        ),
        'CBR_AVOCA_REMIS_AGRUP_V' =>
        array(
            'id_remision_titulo_agrup' => 'id_remision_titulo_agrup',
            'no_remision_agrup' => 'no_remision_agrup',
            'numero_remision_agrup' => 'numero_remision_agrup',
            'anho_remision_agrup' => 'anho_remision_agrup',
            'date_remision_agrup' => 'date_remision_agrup',
            'numero_correpondencia_agrup' => 'numero_correpondencia_agrup'
        ),
        'CBR_AVOCA_CONOC' =>
        array(
            'no_auto' => 'no_auto',
            'fecha' => 'fecha_avoca',
            'id_tipo_documento' => 'id_tipo_documento'
        ),
        'CBR_TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'descripcion_tipdoc'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'no_auto', 'fecha', 'fecha_log desc', 'id_notifica_avoca desc'
    ); //campos para el ordenamiento de la consulta


    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_NOTIFICA_AVOCA' =>
        array(
            'id_notifica_avoca,a' => array('!=' => array(-1)),
            'id_notifica_avoca,b' => array('=' => array('id_notifica_avoca')),
            'id_avoca_conoc' => array('=' => array('id_avoca_conoc')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas

    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_notifica_avoca'; //identificador unico de la tabla


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_notifica_avoca'; //identificador de la tabla
    protected $id_names = array('id_notifica_avoca'); //llave primaria
    protected $field_names = array('id_avoca_conoc', 'fecha', 'observaciones', 'adjunto',
        'estado', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_NOTIFICA_AVOCA'; //tabla en la cual se aplican los cambios 

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Campos de log - 20200221
            $request['usuario_log'] = $request['id_username'];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            try {

                $id_notifica_avoca = $list_data_post[0]['id_notifica_avoca'];

                //LLamar envioNotificacion
                $this->envioNotificacion($request, $id_notifica_avoca);
            } catch (Exception $e) {
                
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Correo de notificacion de notificar avoca - 20200309
     * 
     * @param type $request
     * @param type $id_filtro
     */
    public function envioNotificacion($request, $id_filtro) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a envioNotificacion");

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        $correoEnvio = "";
        $service_url = "";
        foreach ($array as $routeName => $routeData) {
            if ('service_url_local' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $service_url = $value;
                    }
                }
            }
            if ('correoEnvio' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $correoEnvio = $value;
                    }
                }
            }
            $int++;
        }

        /**
         * Envio de correo - 20190911
         */
        $logger->info("Envio de correo inicio ");

        //URL de servicio correo
        $url = $service_url . "curl_envio_correo/list.json";

        $comando = $request['comando'];
        $id_username = $request['id_username'];
        $username = $request['username'];

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CBR_NOTIFICA_AVOCA');

        //Sql
        $sql = <<<EOD
select 
                
usu.username,
'$comando' as comando,               
avoc.id_avoca_conoc as id_tabla,
'$id_mae_bd' as id_mae_bd,
'$id_username' as id_username,
                
avoc.id_avoca_conoc,
avoc.no_auto,
remi.numero_remision,
remi.anho_remision as id_anhos,
avocagrup.cod_titulo_det_agrup as cod_titulo,
ter.id_tipo_doc,
ter.num_doc,
ter.razon_soc,
abo.email as correo,
'$correoEnvio' as email_envio,
'' as mensaje_extra,
'' as mensaje_firma,
'Se realiza la '|| case when notavoc.estado = 1 then 'solicitud de aprobar' else 'devolución del' end ||' avoca registo '|| tipdoc.descripcion || ' de los titulos mineros ' || avocagrup.cod_titulo_det_agrup  || ', verificar recepciones No.'|| avocagrup.no_remision_agrup 
    || ', se envia por observaciones: '|| notavoc.observaciones as mensaje,
case when notavoc.estado = 1 then 'Solicitud Aprob ' else 'Devuelto Abog ' end || ' AVOCA - Recepciones No.'|| avocagrup.no_remision_agrup || ' de los titulos mineros: ' || avocagrup.cod_titulo_det_agrup as subject,        

                
--datos de envio
case when notavoc.estado = 0 then ter.num_doc else ter.num_doc end as num_doc_env,
case when notavoc.estado = 0 then ter.id_tipo_doc else ter.id_tipo_doc end as id_tipo_doc_env,
case when notavoc.estado = 0 then ter.razon_soc else ter.razon_soc end as razon_social_env,
case when notavoc.estado = 0 then abo.email else usuaprob.email end as correo_env,

--datos de envio usuario
usu.num_doc as num_doc_usu,
usu.id_tipo_doc as id_tipo_doc_usu,
usu.nombre || ' ' || usu.nombre as razon_social_usu,
usu.email as correo_usu

from cbr_notifica_avoca notavoc

left join cbr_avoca_conoc avoc
on notavoc.id_avoca_conoc = avoc.id_avoca_conoc

left join CBR_AVOCA_REMIS_AGRUP_V avocagrup
on notavoc.id_avoca_conoc = avocagrup.id_avoca_conoc

left join cbr_tipo_documento tipdoc
on tipdoc.id_tipo_documento = avoc.id_tipo_documento

left join cbr_reparto repa
on repa.id_remision_titulo = avocagrup.id_remision_titulo

left join cbr_remision_titulo remi
on avocagrup.id_remision_titulo = remi.id_remision_titulo

left join cbr_abogado abo
on abo.id_abogado = repa.id_abogado

left join interceros_v ter
on ter.id_mae_ter = abo.id_mae_ter

left join cbr_aprob_deneg_ult_v aprob
on aprob.id_remision_titulo = avocagrup.id_remision_titulo

left join interceros_v teraprob
on teraprob.id_mae_ter = aprob.usuario_log

left join usuario usuaprob
on usuaprob.num_doc = teraprob.num_doc

left join usuario usu
on usu.username = '$username'

where
notavoc.id_notifica_avoca = $id_filtro 
and repa.estado = 1  
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        $this->logMessage("Envio correo");

        if (count($records) > 0) {

            /**
             * Datos de envio
             *
              $params = array(
              'user_from' => 'webservice',
              'recipients' => $recipients,
              'asunto' => 'Error webservie_sigm_consulta',
              'body' => $body
              );
             * 
             */
            $record = $records[0];

            foreach ($record as $key => $value) {
                $params[$key] = $value;
            }

            $params['correo_usu'] = null;

            if ($service_url != null) {
                CN_TABLE::curlPostAsync($url, $params);
            }
        }

        $logger->info("Envio de correo fin");
    }

}
